import { ModuleWithProviders } from '@angular/core';
import { DoubleAgentValidatorV2 } from './validator-v2.service';
import { DoubleAgentValidatorConfig } from './models/validator-config';
import { DoubleAgentValidator } from './validator.service';
import { DoubleAgentFormGroupBuilder } from './form/form-group-builder.service';
import { DoubleAgentValueVerifier } from './value-verifier.service';
import { DoubleAgentFormControlValidatorBuilder } from './form/form-control-validator-builder.service';
export declare const DOUBLE_AGENT_VALIDATOR_PROVIDERS: (typeof DoubleAgentFormControlValidatorBuilder | typeof DoubleAgentFormGroupBuilder | typeof DoubleAgentValueVerifier | {
    provide: typeof DoubleAgentValidator;
    useClass: typeof DoubleAgentValidatorV2;
})[];
export declare class DoubleAgentValidatorV2Module {
    static forRoot(config: DoubleAgentValidatorConfig): ModuleWithProviders;
}
