var __decorate = (this && this.__decorate) || function (decorators, target, key, desc) {
    var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
    if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
    else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
    return c > 3 && r && Object.defineProperty(target, key, r), r;
};
import { NgModule } from '@angular/core';
import { DoubleAgentValidatorV2 } from './validator-v2.service';
import { DoubleAgentValidatorConfig } from './models/validator-config';
import { DoubleAgentValidator } from './validator.service';
import { DoubleAgentFormGroupBuilder } from './form/form-group-builder.service';
import { DoubleAgentValueVerifier } from './value-verifier.service';
import { DoubleAgentFormControlValidatorBuilder } from './form/form-control-validator-builder.service';
import { DoubleAgentValidatorDirectivesModule } from './directives.module';
import { ReactiveFormsModule, FormsModule } from '@angular/forms';
export var DOUBLE_AGENT_VALIDATOR_PROVIDERS = [
    {
        provide: DoubleAgentValidator,
        useClass: DoubleAgentValidatorV2,
    },
    DoubleAgentFormGroupBuilder,
    DoubleAgentFormControlValidatorBuilder,
    DoubleAgentValueVerifier,
    DoubleAgentFormControlValidatorBuilder
];
var DoubleAgentValidatorV2Module = DoubleAgentValidatorV2Module_1 = (function () {
    function DoubleAgentValidatorV2Module() {
    }
    DoubleAgentValidatorV2Module.forRoot = function (config) {
        return {
            ngModule: DoubleAgentValidatorV2Module_1,
            providers: [
                {
                    provide: DoubleAgentValidatorConfig,
                    useValue: config,
                }
            ].concat(DOUBLE_AGENT_VALIDATOR_PROVIDERS),
        };
    };
    return DoubleAgentValidatorV2Module;
}());
DoubleAgentValidatorV2Module = DoubleAgentValidatorV2Module_1 = __decorate([
    NgModule({
        imports: [
            FormsModule,
            ReactiveFormsModule,
            DoubleAgentValidatorDirectivesModule
        ],
        exports: [
            DoubleAgentValidatorDirectivesModule
        ]
    })
], DoubleAgentValidatorV2Module);
export { DoubleAgentValidatorV2Module };
var DoubleAgentValidatorV2Module_1;
//# sourceMappingURL=validator-v2.module.js.map